diff -uNr openmp-3.5.0.src/runtime/src/kmp_runtime.c openmp-3.5.0.src.r219214/runtime/src/kmp_runtime.c
--- openmp-3.5.0.src/runtime/src/kmp_runtime.c	2014-08-07 07:16:59.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/src/kmp_runtime.c	2014-10-24 19:58:41.000000000 -0400
@@ -4624,19 +3542,24 @@
 void
 __kmp_unregister_root_current_thread( int gtid )
 {
+    KA_TRACE( 1, ("__kmp_unregister_root_current_thread: enter T#%d\n", gtid ));
+    /* this lock should be ok, since unregister_root_current_thread is never called during
+     * and abort, only during a normal close.  furthermore, if you have the
+     * forkjoin lock, you should never try to get the initz lock */
+
+    __kmp_acquire_bootstrap_lock( &__kmp_forkjoin_lock );
+    if( TCR_4(__kmp_global.g.g_done) || !__kmp_init_serial ) {
+        KC_TRACE( 10, ("__kmp_unregister_root_current_thread: already finished, exiting T#%d\n", gtid ));
+        __kmp_release_bootstrap_lock( &__kmp_forkjoin_lock );
+        return;
+    }
     kmp_root_t *root = __kmp_root[gtid];
 
-    KA_TRACE( 1, ("__kmp_unregister_root_current_thread: enter T#%d\n", gtid ));
     KMP_DEBUG_ASSERT( __kmp_threads && __kmp_threads[gtid] );
     KMP_ASSERT( KMP_UBER_GTID( gtid ));
     KMP_ASSERT( root == __kmp_threads[gtid]->th.th_root );
     KMP_ASSERT( root->r.r_active == FALSE );
 
-    /* this lock should be ok, since unregister_root_current_thread is never called during
-     * and abort, only during a normal close.  furthermore, if you have the
-     * forkjoin lock, you should never try to get the initz lock */
-
-    __kmp_acquire_bootstrap_lock( &__kmp_forkjoin_lock );
 
     KMP_MB();
 
@@ -4675,24 +3598,20 @@
     return r;
 }
 
-#if OMP_30_ENABLED
-
 #if KMP_DEBUG
 void __kmp_task_info() {
 
     kmp_int32 gtid       = __kmp_entry_gtid();
     kmp_int32 tid        = __kmp_tid_from_gtid( gtid );
     kmp_info_t *this_thr = __kmp_threads[ gtid ];
-    kmp_team_t *steam    = this_thr -> th.th_serial_team;
-    kmp_team_t *team     = this_thr -> th.th_team;
+    kmp_team_t *steam    = this_thr->th.th_serial_team;
+    kmp_team_t *team     = this_thr->th.th_team;
 
     __kmp_printf( "__kmp_task_info: gtid=%d tid=%d t_thread=%p team=%p curtask=%p ptask=%p\n",
         gtid, tid, this_thr, team, this_thr->th.th_current_task, team->t.t_implicit_task_taskdata[tid].td_parent );
 }
 #endif // KMP_DEBUG
 
-#endif // OMP_30_ENABLED
-
 /* TODO optimize with one big memclr, take out what isn't needed,
  * split responsility to workers as much as possible, and delay
  * initialization of features as much as possible  */
@@ -4701,14 +3620,14 @@
 {
     /* this_thr->th.th_info.ds.ds_gtid is setup in kmp_allocate_thread/create_worker
      * this_thr->th.th_serial_team is setup in __kmp_allocate_thread */
-
+    kmp_info_t *master = team->t.t_threads[0];
     KMP_DEBUG_ASSERT( this_thr != NULL );
-    KMP_DEBUG_ASSERT( this_thr -> th.th_serial_team );
+    KMP_DEBUG_ASSERT( this_thr->th.th_serial_team );
     KMP_DEBUG_ASSERT( team );
-    KMP_DEBUG_ASSERT( team -> t.t_threads  );
-    KMP_DEBUG_ASSERT( team -> t.t_dispatch );
-    KMP_DEBUG_ASSERT( team -> t.t_threads[0] );
-    KMP_DEBUG_ASSERT( team -> t.t_threads[0] -> th.th_root );
+    KMP_DEBUG_ASSERT( team->t.t_threads  );
+    KMP_DEBUG_ASSERT( team->t.t_dispatch );
+    KMP_DEBUG_ASSERT( master );
+    KMP_DEBUG_ASSERT( master->th.th_root );
 
     KMP_MB();
 
@@ -4722,21 +3641,15 @@
     this_thr->th.th_new_place       = this_thr->th.th_current_place;
 # endif
 #endif
-    this_thr->th.th_root            = team -> t.t_threads[0] -> th.th_root;
+    this_thr->th.th_root            = master->th.th_root;
 
     /* setup the thread's cache of the team structure */
-    this_thr->th.th_team_nproc      = team -> t.t_nproc;
-    this_thr->th.th_team_master     = team -> t.t_threads[0];
-    this_thr->th.th_team_serialized = team -> t.t_serialized;
-#if OMP_40_ENABLED
-    this_thr->th.th_team_microtask  = team -> t.t_threads[0] -> th.th_team_microtask;
-    this_thr->th.th_teams_level     = team -> t.t_threads[0] -> th.th_teams_level;
-    this_thr->th.th_set_nth_teams   = team -> t.t_threads[0] -> th.th_set_nth_teams;
-#endif /* OMP_40_ENABLED */
+    this_thr->th.th_team_nproc      = team->t.t_nproc;
+    this_thr->th.th_team_master     = master;
+    this_thr->th.th_team_serialized = team->t.t_serialized;
     TCW_PTR(this_thr->th.th_sleep_loc, NULL);
 
-#if OMP_30_ENABLED
-    KMP_DEBUG_ASSERT( team -> t.t_implicit_task_taskdata );
+    KMP_DEBUG_ASSERT( team->t.t_implicit_task_taskdata );
     this_thr->th.th_task_state = 0;
 
     KF_TRACE( 10, ( "__kmp_initialize_info1: T#%d:%d this_thread=%p curtask=%p\n",
@@ -4747,13 +3660,11 @@
     KF_TRACE( 10, ( "__kmp_initialize_info2: T#%d:%d this_thread=%p curtask=%p\n",
                     tid, gtid, this_thr, this_thr->th.th_current_task ) );
     // TODO: Initialize ICVs from parent; GEH - isn't that already done in __kmp_initialize_team()?
-#endif // OMP_30_ENABLED
 
     /* TODO no worksharing in speculative threads */
-    this_thr -> th.th_dispatch      = &team -> t.t_dispatch[ tid ];
+    this_thr->th.th_dispatch      = &team->t.t_dispatch[ tid ];
 
     this_thr->th.th_local.this_construct = 0;
-    this_thr->th.th_local.last_construct = 0;
 
 #ifdef BUILD_TV
     this_thr->th.th_local.tv_data = 0;
@@ -4772,7 +3683,7 @@
 
     /* Initialize dynamic dispatch */
     {
-        volatile kmp_disp_t *dispatch = this_thr -> th.th_dispatch;
+        volatile kmp_disp_t *dispatch = this_thr->th.th_dispatch;
         /*
          * Use team max_nproc since this will never change for the team.
          */
@@ -4780,13 +3691,13 @@
             ( team->t.t_max_nproc == 1 ? 1 : KMP_MAX_DISP_BUF );
         KD_TRACE( 10, ("__kmp_initialize_info: T#%d max_nproc: %d\n", gtid, team->t.t_max_nproc ) );
         KMP_ASSERT( dispatch );
-        KMP_DEBUG_ASSERT( team -> t.t_dispatch );
+        KMP_DEBUG_ASSERT( team->t.t_dispatch );
         KMP_DEBUG_ASSERT( dispatch == &team->t.t_dispatch[ tid ] );
 
         dispatch->th_disp_index = 0;
 
-        if( ! dispatch -> th_disp_buffer )  {
-            dispatch -> th_disp_buffer = (dispatch_private_info_t *) __kmp_allocate( disp_size );
+        if( ! dispatch->th_disp_buffer )  {
+            dispatch->th_disp_buffer = (dispatch_private_info_t *) __kmp_allocate( disp_size );
 
             if ( __kmp_storage_map ) {
                 __kmp_print_storage_map_gtid( gtid, &dispatch->th_disp_buffer[ 0 ],
@@ -4796,14 +3707,14 @@
                                          gtid, team->t.t_id, gtid );
             }
         } else {
-            memset( & dispatch -> th_disp_buffer[0], '\0', disp_size );
+            memset( & dispatch->th_disp_buffer[0], '\0', disp_size );
         }
 
-        dispatch -> th_dispatch_pr_current = 0;
-        dispatch -> th_dispatch_sh_current = 0;
+        dispatch->th_dispatch_pr_current = 0;
+        dispatch->th_dispatch_sh_current = 0;
 
-        dispatch -> th_deo_fcn = 0;             /* ORDERED     */
-        dispatch -> th_dxo_fcn = 0;             /* END ORDERED */
+        dispatch->th_deo_fcn = 0;             /* ORDERED     */
+        dispatch->th_dxo_fcn = 0;             /* END ORDERED */
     }
 
     this_thr->th.th_next_pool = NULL;
@@ -4830,7 +3741,9 @@
 
     KA_TRACE( 20, ("__kmp_allocate_thread: T#%d\n", __kmp_get_gtid() ));
     KMP_DEBUG_ASSERT( root && team );
+#if !KMP_NESTED_HOT_TEAMS
     KMP_DEBUG_ASSERT( KMP_MASTER_GTID( __kmp_get_gtid() ));
+#endif
     KMP_MB();
 
     /* first, try to get one from the thread pool */
@@ -4851,7 +3764,7 @@
 
         KA_TRACE( 20, ("__kmp_allocate_thread: T#%d using thread T#%d\n",
                     __kmp_get_gtid(), new_thr->th.th_info.ds.ds_gtid ));
-        KMP_ASSERT(       ! new_thr -> th.th_team );
+        KMP_ASSERT(       ! new_thr->th.th_team );
         KMP_DEBUG_ASSERT( __kmp_nth < __kmp_threads_capacity );
         KMP_DEBUG_ASSERT( __kmp_thread_pool_nth >= 0 );
 
@@ -4871,6 +3784,14 @@
         }
 #endif /* KMP_ADJUST_BLOCKTIME */
 
+#if KMP_DEBUG
+        // If thread entered pool via __kmp_free_thread, wait_flag should != KMP_BARRIER_PARENT_FLAG.
+        int b;
+        kmp_balign_t * balign = new_thr->th.th_bar;
+        for( b = 0; b < bs_last_barrier; ++ b )
+            KMP_DEBUG_ASSERT(balign[b].bb.wait_flag != KMP_BARRIER_PARENT_FLAG);
+#endif
+
         KF_TRACE( 10, ("__kmp_allocate_thread: T#%d using thread %p T#%d\n",
                     __kmp_get_gtid(), new_thr, new_thr->th.th_info.ds.ds_gtid ));
 
@@ -4927,30 +3848,19 @@
 
     /* add the reserve serialized team, initialized from the team's master thread */
     {
-    #if OMP_30_ENABLED
     kmp_internal_control_t r_icvs = __kmp_get_x_global_icvs( team );
-    #endif // OMP_30_ENABLED
     KF_TRACE( 10, ( "__kmp_allocate_thread: before th_serial/serial_team\n" ) );
-    new_thr -> th.th_serial_team = serial_team =
+    new_thr->th.th_serial_team = serial_team =
         (kmp_team_t*) __kmp_allocate_team( root, 1, 1,
 #if OMP_40_ENABLED
                                            proc_bind_default,
 #endif
-#if OMP_30_ENABLED
                                            &r_icvs,
-#else
-                                           team->t.t_set_nproc[0],
-                                           team->t.t_set_dynamic[0],
-                                           team->t.t_set_nested[0],
-                                           team->t.t_set_blocktime[0],
-                                           team->t.t_set_bt_intervals[0],
-                                           team->t.t_set_bt_set[0],
-#endif // OMP_30_ENABLED
-                                           0 );
+                                           0 USE_NESTED_HOT_ARG(NULL) );
     }
     KMP_ASSERT ( serial_team );
-    serial_team -> t.t_serialized = 0;   // AC: the team created in reserve, not for execution (it is unused for now).
-    serial_team -> t.t_threads[0] = new_thr;
+    serial_team->t.t_serialized = 0;   // AC: the team created in reserve, not for execution (it is unused for now).
+    serial_team->t.t_threads[0] = new_thr;
     KF_TRACE( 10, ( "__kmp_allocate_thread: after th_serial/serial_team : new_thr=%p\n",
       new_thr ) );
 
@@ -4962,7 +3872,7 @@
     #endif /* USE_FAST_MEMORY */
 
     #if KMP_USE_BGET
-        KMP_DEBUG_ASSERT( new_thr -> th.th_local.bget_data == NULL );
+        KMP_DEBUG_ASSERT( new_thr->th.th_local.bget_data == NULL );
         __kmp_initialize_bget( new_thr );
     #endif
 
@@ -4972,11 +3882,14 @@
     KA_TRACE( 20, ("__kmp_allocate_thread: T#%d init go fork=%u, plain=%u\n",
                     __kmp_get_gtid(), KMP_INIT_BARRIER_STATE, KMP_INIT_BARRIER_STATE ));
 
-    new_thr->th.th_bar[ bs_forkjoin_barrier ].bb.b_go = KMP_INIT_BARRIER_STATE;
-    new_thr->th.th_bar[ bs_plain_barrier    ].bb.b_go = KMP_INIT_BARRIER_STATE;
-    #if KMP_FAST_REDUCTION_BARRIER
-    new_thr->th.th_bar[ bs_reduction_barrier ].bb.b_go = KMP_INIT_BARRIER_STATE;
-    #endif // KMP_FAST_REDUCTION_BARRIER
+    int b;
+    kmp_balign_t * balign = new_thr->th.th_bar;
+    for(b=0; b<bs_last_barrier; ++b) {
+        balign[b].bb.b_go = KMP_INIT_BARRIER_STATE;
+        balign[b].bb.team = NULL;
+        balign[b].bb.wait_flag = KMP_BARRIER_NOT_WAITING;
+        balign[b].bb.use_oncore_barrier = 0;
+    }
 
     new_thr->th.th_spin_here = FALSE;
     new_thr->th.th_next_waiting = 0;
@@ -5045,109 +3958,23 @@
  * IF YOU TOUCH THIS ROUTINE, RUN EPCC C SYNCBENCH ON A BIG-IRON MACHINE!!!
  */
 static void
-__kmp_reinitialize_team( kmp_team_t *team,
-#if OMP_30_ENABLED
-                         kmp_internal_control_t *new_icvs, ident_t *loc
-#else
-                         int new_set_nproc, int new_set_dynamic, int new_set_nested,
-                         int new_set_blocktime, int new_bt_intervals, int new_bt_set
-#endif
-                         ) {
+__kmp_reinitialize_team( kmp_team_t *team, kmp_internal_control_t *new_icvs, ident_t *loc ) {
     KF_TRACE( 10, ( "__kmp_reinitialize_team: enter this_thread=%p team=%p\n",
                     team->t.t_threads[0], team ) );
-#if OMP_30_ENABLED
     KMP_DEBUG_ASSERT( team && new_icvs);
     KMP_DEBUG_ASSERT( ( ! TCR_4(__kmp_init_parallel) ) || new_icvs->nproc );
     team->t.t_ident = loc;
-#else
-    KMP_DEBUG_ASSERT( team && new_set_nproc );
-#endif // OMP_30_ENABLED
 
     team->t.t_id = KMP_GEN_TEAM_ID();
 
     // Copy ICVs to the master thread's implicit taskdata
-#if OMP_30_ENABLED
-    load_icvs(new_icvs);
     __kmp_init_implicit_task( loc, team->t.t_threads[0], team, 0, FALSE );
-    store_icvs(&team->t.t_implicit_task_taskdata[0].td_icvs, new_icvs);
-    sync_icvs();
-# else
-    team -> t.t_set_nproc[0]   = new_set_nproc;
-    team -> t.t_set_dynamic[0] = new_set_dynamic;
-    team -> t.t_set_nested[0]  = new_set_nested;
-    team -> t.t_set_blocktime[0]   = new_set_blocktime;
-    team -> t.t_set_bt_intervals[0] = new_bt_intervals;
-    team -> t.t_set_bt_set[0]  = new_bt_set;
-# endif // OMP_30_ENABLED
+    copy_icvs(&team->t.t_implicit_task_taskdata[0].td_icvs, new_icvs);
 
     KF_TRACE( 10, ( "__kmp_reinitialize_team: exit this_thread=%p team=%p\n",
                     team->t.t_threads[0], team ) );
 }
 
-static void
-__kmp_setup_icv_copy(kmp_team_t *  team, int           new_nproc,
-#if OMP_30_ENABLED
-                kmp_internal_control_t * new_icvs,
-                ident_t *                loc
-#else
-                int new_set_nproc, int new_set_dynamic, int new_set_nested,
-                int new_set_blocktime, int new_bt_intervals, int new_bt_set
-#endif // OMP_30_ENABLED
-                )
-{
-    int f;
-
-#if OMP_30_ENABLED
-    KMP_DEBUG_ASSERT( team && new_nproc && new_icvs );
-    KMP_DEBUG_ASSERT( ( ! TCR_4(__kmp_init_parallel) ) || new_icvs->nproc );
-#else
-    KMP_DEBUG_ASSERT( team && new_nproc && new_set_nproc );
-#endif // OMP_30_ENABLED
-
-    // Master thread's copy of the ICVs was set up on the implicit taskdata in __kmp_reinitialize_team.
-    // __kmp_fork_call() assumes the master thread's implicit task has this data before this function is called.
-#if KMP_BARRIER_ICV_PULL
-    // Copy the ICVs to master's thread structure into th_fixed_icvs (which remains untouched), where all of the
-    // worker threads can access them and make their own copies after the barrier.
-    load_icvs(new_icvs);
-    KMP_DEBUG_ASSERT(team->t.t_threads[0]);  // the threads arrays should be allocated at this point
-    store_icvs(&team->t.t_threads[0]->th.th_fixed_icvs, new_icvs);
-    sync_icvs();
-    KF_TRACE(10, ("__kmp_setup_icv_copy: PULL: T#%d this_thread=%p team=%p\n", 0, team->t.t_threads[0], team));
-
-#elif KMP_BARRIER_ICV_PUSH
-    // The ICVs will be propagated in the fork barrier, so nothing needs to be done here.
-    KF_TRACE(10, ("__kmp_setup_icv_copy: PUSH: T#%d this_thread=%p team=%p\n", 0, team->t.t_threads[0], team));
-
-#else
-    // Copy the ICVs to each of the non-master threads.  This takes O(nthreads) time.
-# if OMP_30_ENABLED
-    load_icvs(new_icvs);
-# endif // OMP_30_ENABLED
-    KMP_DEBUG_ASSERT(team->t.t_threads[0]);  // the threads arrays should be allocated at this point
-    for(f=1 ; f<new_nproc ; f++) { // skip the master thread
-# if OMP_30_ENABLED
-        // TODO: GEH - pass in better source location info since usually NULL here
-        KF_TRACE( 10, ( "__kmp_setup_icv_copy: LINEAR: T#%d this_thread=%p team=%p\n",
-                        f, team->t.t_threads[f], team ) );
-        __kmp_init_implicit_task( loc, team->t.t_threads[f], team, f, FALSE );
-        store_icvs(&team->t.t_implicit_task_taskdata[f].td_icvs, new_icvs);
-        KF_TRACE( 10, ( "__kmp_setup_icv_copy: LINEAR: T#%d this_thread=%p team=%p\n",
-                        f, team->t.t_threads[f], team ) );
-# else
-        team -> t.t_set_nproc[f]   = new_set_nproc;
-        team -> t.t_set_dynamic[f] = new_set_dynamic;
-        team -> t.t_set_nested[f]  = new_set_nested;
-        team -> t.t_set_blocktime[f]   = new_set_blocktime;
-        team -> t.t_set_bt_intervals[f] = new_bt_intervals;
-        team -> t.t_set_bt_set[f]  = new_bt_set;
-# endif // OMP_30_ENABLED
-    }
-# if OMP_30_ENABLED
-    sync_icvs();
-# endif // OMP_30_ENABLED
-#endif // KMP_BARRIER_ICV_PULL
-}
 
 /* initialize the team data structure
  * this assumes the t_threads and t_max_nproc are already set
@@ -5156,13 +3983,8 @@
 __kmp_initialize_team(
     kmp_team_t * team,
     int          new_nproc,
-    #if OMP_30_ENABLED
-        kmp_internal_control_t * new_icvs,
-        ident_t *                loc
-    #else
-        int new_set_nproc, int new_set_dynamic, int new_set_nested,
-        int new_set_blocktime, int new_bt_intervals, int new_bt_set
-    #endif // OMP_30_ENABLED
+    kmp_internal_control_t * new_icvs,
+    ident_t *                loc
 ) {
     KF_TRACE( 10, ( "__kmp_initialize_team: enter: team=%p\n", team ) );
 
@@ -5172,53 +3994,43 @@
     KMP_DEBUG_ASSERT( team->t.t_threads );
     KMP_MB();
 
-    team -> t.t_master_tid  = 0;    /* not needed */
-    /* team -> t.t_master_bar;        not needed */
-    team -> t.t_serialized  = new_nproc > 1 ? 0 : 1;
-    team -> t.t_nproc       = new_nproc;
-
-    /* team -> t.t_parent     = NULL; TODO not needed & would mess up hot team */
-    team -> t.t_next_pool   = NULL;
-    /* memset( team -> t.t_threads, 0, sizeof(kmp_info_t*)*new_nproc ); would mess up hot team */
+    team->t.t_master_tid  = 0;    /* not needed */
+    /* team->t.t_master_bar;        not needed */
+    team->t.t_serialized  = new_nproc > 1 ? 0 : 1;
+    team->t.t_nproc       = new_nproc;
+
+    /* team->t.t_parent     = NULL; TODO not needed & would mess up hot team */
+    team->t.t_next_pool   = NULL;
+    /* memset( team->t.t_threads, 0, sizeof(kmp_info_t*)*new_nproc ); would mess up hot team */
 
     TCW_SYNC_PTR(team->t.t_pkfn, NULL); /* not needed */
-    team -> t.t_invoke      = NULL; /* not needed */
+    team->t.t_invoke      = NULL; /* not needed */
 
-#if OMP_30_ENABLED
-    // TODO???: team -> t.t_max_active_levels       = new_max_active_levels;
-    team -> t.t_sched       = new_icvs->sched;
-#endif // OMP_30_ENABLED
+    // TODO???: team->t.t_max_active_levels       = new_max_active_levels;
+    team->t.t_sched       = new_icvs->sched;
 
 #if KMP_ARCH_X86 || KMP_ARCH_X86_64
-    team -> t.t_fp_control_saved = FALSE; /* not needed */
-    team -> t.t_x87_fpu_control_word = 0; /* not needed */
-    team -> t.t_mxcsr = 0;                /* not needed */
+    team->t.t_fp_control_saved = FALSE; /* not needed */
+    team->t.t_x87_fpu_control_word = 0; /* not needed */
+    team->t.t_mxcsr = 0;                /* not needed */
 #endif /* KMP_ARCH_X86 || KMP_ARCH_X86_64 */
 
-    team -> t.t_construct   = 0;
-    __kmp_init_lock( & team -> t.t_single_lock );
+    team->t.t_construct   = 0;
+    __kmp_init_lock( & team->t.t_single_lock );
 
-    team -> t.t_ordered .dt.t_value = 0;
-    team -> t.t_master_active = FALSE;
+    team->t.t_ordered .dt.t_value = 0;
+    team->t.t_master_active = FALSE;
 
-    memset( & team -> t.t_taskq, '\0', sizeof( kmp_taskq_t ));
+    memset( & team->t.t_taskq, '\0', sizeof( kmp_taskq_t ));
 
 #ifdef KMP_DEBUG
-    team -> t.t_copypriv_data = NULL;  /* not necessary, but nice for debugging */
+    team->t.t_copypriv_data = NULL;  /* not necessary, but nice for debugging */
 #endif
-    team -> t.t_copyin_counter = 0;    /* for barrier-free copyin implementation */
+    team->t.t_copyin_counter = 0;    /* for barrier-free copyin implementation */
 
-    team -> t.t_control_stack_top = NULL;
-
-    __kmp_reinitialize_team( team,
-#if OMP_30_ENABLED
-                             new_icvs, loc
-#else
-                             new_set_nproc, new_set_dynamic, new_set_nested,
-                             new_set_blocktime, new_bt_intervals, new_bt_set
-#endif // OMP_30_ENABLED
-                             );
+    team->t.t_control_stack_top = NULL;
 
+    __kmp_reinitialize_team( team, new_icvs, loc );
 
     KMP_MB();
     KF_TRACE( 10, ( "__kmp_initialize_team: exit: team=%p\n", team ) );
@@ -5324,7 +4136,7 @@
                     if ( place == last_place ) {
                         place = first_place;
                     }
-                    else if ( place == __kmp_affinity_num_masks - 1) {
+                    else if ( place == (int)(__kmp_affinity_num_masks - 1) ) {
                         place = 0;
                     }
                     else {
@@ -5364,7 +4176,7 @@
                         if ( place == last_place ) {
                             place = first_place;
                         }
-                        else if ( place == __kmp_affinity_num_masks - 1) {
+                        else if ( place == (int)(__kmp_affinity_num_masks - 1) ) {
                             place = 0;
                         }
                         else {
@@ -5378,7 +4190,7 @@
                         if ( place == last_place ) {
                             place = first_place;
                         }
-                        else if ( place == __kmp_affinity_num_masks - 1) {
+                        else if ( place == (int)(__kmp_affinity_num_masks - 1) ) {
                             place = 0;
                         }
                         else {
@@ -5427,7 +4239,7 @@
                         if ( place == last_place ) {
                             place = first_place;
                         }
-                        else if ( place == __kmp_affinity_num_masks - 1) {
+                        else if ( place == (int)(__kmp_affinity_num_masks - 1) ) {
                             place = 0;
                         }
                         else {
@@ -5439,7 +4251,7 @@
                         if ( place == last_place ) {
                             place = first_place;
                         }
-                        else if ( place == __kmp_affinity_num_masks - 1) {
+                        else if ( place == (int)(__kmp_affinity_num_masks - 1) ) {
                             place = 0;
                         }
                         else {
@@ -5454,7 +4266,7 @@
                     if ( place == last_place ) {
                         place = first_place;
                     }
-                    else if ( place == __kmp_affinity_num_masks - 1) {
+                    else if ( place == (int)(__kmp_affinity_num_masks - 1) ) {
                         place = 0;
                     }
                     else {
@@ -5493,7 +4305,7 @@
                         if ( place == last_place ) {
                             place = first_place;
                         }
-                        else if ( place == __kmp_affinity_num_masks - 1) {
+                        else if ( place == (int)(__kmp_affinity_num_masks - 1) ) {
                             place = 0;
                         }
                         else {
@@ -5507,7 +4319,7 @@
                         if ( place == last_place ) {
                             place = first_place;
                         }
-                        else if ( place == __kmp_affinity_num_masks - 1) {
+                        else if ( place == (int)(__kmp_affinity_num_masks - 1) ) {
                             place = 0;
                         }
                         else {
@@ -5542,49 +4354,106 @@
 #if OMP_40_ENABLED
     kmp_proc_bind_t new_proc_bind,
 #endif
-#if OMP_30_ENABLED
     kmp_internal_control_t *new_icvs,
-#else
-    int new_set_nproc, int new_set_dynamic, int new_set_nested,
-    int new_set_blocktime, int new_bt_intervals, int new_bt_set,
-#endif
-    int argc )
+    int argc USE_NESTED_HOT_ARG(kmp_info_t *master) )
 {
+    KMP_TIME_BLOCK(KMP_allocate_team);
     int f;
     kmp_team_t *team;
     char *ptr;
     size_t size;
+    int use_hot_team = ! root->r.r_active;
 
     KA_TRACE( 20, ("__kmp_allocate_team: called\n"));
     KMP_DEBUG_ASSERT( new_nproc >=1 && argc >=0 );
     KMP_DEBUG_ASSERT( max_nproc >= new_nproc );
     KMP_MB();
 
-    //
-    // optimization to use a "hot" team for the top level,
-    // as it is usually the same
-    //
-    if ( ! root->r.r_active  &&  new_nproc > 1 ) {
+#if KMP_NESTED_HOT_TEAMS
+    int level;
+    kmp_hot_team_ptr_t *hot_teams;
+    if( master ) {
+        team = master->th.th_team;
+        level = team->t.t_active_level;
+        if( master->th.th_teams_microtask ) {                         // in teams construct?
+            if( master->th.th_teams_size.nteams > 1 && (             // #teams > 1
+                team->t.t_pkfn == (microtask_t)__kmp_teams_master || // inner fork of the teams
+                master->th.th_teams_level < team->t.t_level ) ) {    // or nested parallel inside the teams
+                ++level; // not increment if #teams==1, or for outer fork of the teams; increment otherwise
+            }
+        }
+        hot_teams = master->th.th_hot_teams;
+        if( level < __kmp_hot_teams_max_level && hot_teams && hot_teams[level].hot_team )
+        {   // hot team has already been allocated for given level
+            use_hot_team = 1;
+        } else {
+            use_hot_team = 0;
+        }
+    }
+#endif
+    // Optimization to use a "hot" team
+    if( use_hot_team && new_nproc > 1 ) {
+        KMP_DEBUG_ASSERT( new_nproc == max_nproc );
+#if KMP_NESTED_HOT_TEAMS
+        team = hot_teams[level].hot_team;
+#else
+        team =  root->r.r_hot_team;
+#endif
+#if KMP_DEBUG
+        if ( __kmp_tasking_mode != tskm_immediate_exec ) {
+            KA_TRACE( 20, ("__kmp_allocate_team: hot team task_team = %p before reinit\n",
+                           team->t.t_task_team ));
+        }
+#endif
+
+        // Has the number of threads changed?
+        /* Let's assume the most common case is that the number of threads is unchanged, and
+           put that case first. */
+        if (team->t.t_nproc == new_nproc) { // Check changes in number of threads
+            KA_TRACE( 20, ("__kmp_allocate_team: reusing hot team\n" ));
+#if KMP_MIC
+            // This case can mean that omp_set_num_threads() was called and the hot team size
+            // was already reduced, so we check the special flag
+            if ( team->t.t_size_changed == -1 ) {
+                team->t.t_size_changed = 1;
+            } else {
+                team->t.t_size_changed = 0;
+            }
+#endif
+
+            // TODO???: team->t.t_max_active_levels = new_max_active_levels;
+            team->t.t_sched =  new_icvs->sched;
 
-        KMP_DEBUG_ASSERT( new_nproc == max_nproc );
+            __kmp_reinitialize_team( team, new_icvs, root->r.r_uber_thread->th.th_ident );
 
-        team =  root -> r.r_hot_team;
+            KF_TRACE( 10, ("__kmp_allocate_team2: T#%d, this_thread=%p team=%p\n",
+                           0, team->t.t_threads[0], team ) );
+            __kmp_push_current_task_to_thread( team->t.t_threads[ 0 ], team, 0 );
 
-#if OMP_30_ENABLED && KMP_DEBUG
-        if ( __kmp_tasking_mode != tskm_immediate_exec ) {
-            KA_TRACE( 20, ("__kmp_allocate_team: hot team task_team = %p before reinit\n",
-                           team -> t.t_task_team ));
+#if OMP_40_ENABLED
+# if KMP_AFFINITY_SUPPORTED
+            if ( team->t.t_proc_bind == new_proc_bind ) {
+                KA_TRACE( 200, ("__kmp_allocate_team: reusing hot team #%d bindings: proc_bind = %d, partition = [%d,%d]\n",
+                  team->t.t_id, new_proc_bind, team->t.t_first_place,
+                  team->t.t_last_place ) );
+            }
+            else {
+                team->t.t_proc_bind = new_proc_bind;
+                __kmp_partition_places( team );
+            }
+# else
+            if ( team->t.t_proc_bind != new_proc_bind ) {
+                team->t.t_proc_bind = new_proc_bind;
+            }
+# endif /* KMP_AFFINITY_SUPPORTED */
+#endif /* OMP_40_ENABLED */
         }
-#endif
-
-        /* has the number of threads changed? */
-        if( team -> t.t_nproc > new_nproc ) {
+        else if( team->t.t_nproc > new_nproc ) {
             KA_TRACE( 20, ("__kmp_allocate_team: decreasing hot team thread count to %d\n", new_nproc ));
 
 #if KMP_MIC
-            team -> t.t_size_changed = 1;
+            team->t.t_size_changed = 1;
 #endif
-#if OMP_30_ENABLED
             if ( __kmp_tasking_mode != tskm_immediate_exec ) {
                 kmp_task_team_t *task_team = team->t.t_task_team;
                 if ( ( task_team != NULL ) && TCR_SYNC_4(task_team->tt.tt_active) ) {
@@ -5606,31 +4475,27 @@
                     KMP_DEBUG_ASSERT( task_team == NULL );
                 }
             }
-#endif // OMP_30_ENABLED
-
-            /* release the extra threads we don't need any more */
-            for( f = new_nproc  ;  f < team->t.t_nproc  ;  f++ ) {
-                KMP_DEBUG_ASSERT( team->t.t_threads[ f ] );
-                __kmp_free_thread( team->t.t_threads[ f ] );
-                team -> t.t_threads[ f ] =  NULL;
-            }
-
-            team -> t.t_nproc =  new_nproc;
-#if OMP_30_ENABLED
-            // TODO???: team -> t.t_max_active_levels = new_max_active_levels;
-            team -> t.t_sched =  new_icvs->sched;
-#endif
-            __kmp_reinitialize_team( team,
-#if OMP_30_ENABLED
-                                     new_icvs, root->r.r_uber_thread->th.th_ident
-#else
-                                     new_set_nproc, new_set_dynamic, new_set_nested,
-                                     new_set_blocktime, new_bt_intervals, new_bt_set
-#endif // OMP_30_ENABLED
-                                     );
-
+#if KMP_NESTED_HOT_TEAMS
+            if( __kmp_hot_teams_mode == 0 ) {
+                // AC: saved number of threads should correspond to team's value in this mode,
+                // can be bigger in mode 1, when hot team has some threads in reserve
+                KMP_DEBUG_ASSERT(hot_teams[level].hot_team_nth == team->t.t_nproc);
+                hot_teams[level].hot_team_nth = new_nproc;
+#endif // KMP_NESTED_HOT_TEAMS
+                /* release the extra threads we don't need any more */
+                for( f = new_nproc  ;  f < team->t.t_nproc  ;  f++ ) {
+                    KMP_DEBUG_ASSERT( team->t.t_threads[ f ] );
+                    __kmp_free_thread( team->t.t_threads[ f ] );
+                    team->t.t_threads[ f ] = NULL;
+                }
+#if KMP_NESTED_HOT_TEAMS
+            } // (__kmp_hot_teams_mode == 0)
+#endif // KMP_NESTED_HOT_TEAMS
+            team->t.t_nproc =  new_nproc;
+            // TODO???: team->t.t_max_active_levels = new_max_active_levels;
+            team->t.t_sched =  new_icvs->sched;
+            __kmp_reinitialize_team( team, new_icvs, root->r.r_uber_thread->th.th_ident );
 
-#if OMP_30_ENABLED
             if ( __kmp_tasking_mode != tskm_immediate_exec ) {
                 kmp_task_team_t *task_team = team->t.t_task_team;
                 if ( task_team != NULL ) {
@@ -5640,20 +4505,17 @@
                     task_team->tt.tt_ref_ct = new_nproc - 1;
                 }
             }
-#endif
 
             /* update the remaining threads */
-            for( f = 0  ;  f < new_nproc  ;  f++ ) {
-                team -> t.t_threads[ f ] -> th.th_team_nproc = team->t.t_nproc;
+            for(f = 0; f < new_nproc; ++f) {
+                team->t.t_threads[f]->th.th_team_nproc = new_nproc;
             }
 
-#if OMP_30_ENABLED
             // restore the current task state of the master thread: should be the implicit task
             KF_TRACE( 10, ("__kmp_allocate_team: T#%d, this_thread=%p team=%p\n",
                        0, team->t.t_threads[0], team ) );
 
-            __kmp_push_current_task_to_thread( team -> t.t_threads[ 0 ], team, 0 );
-#endif
+            __kmp_push_current_task_to_thread( team->t.t_threads[ 0 ], team, 0 );
 
 #ifdef KMP_DEBUG
             for ( f = 0; f < team->t.t_nproc; f++ ) {
